#ifndef _CCRC32_H
#define _CCRC32_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define CRC32_POLYNOMIAL 0x04c11db7
#define CRC32_INIT 0xffffffff
#define CRC32_MATCH 0xC704DD7B

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CCRC32 {

   public:
      typedef unsigned long crc_type;
      typedef unsigned long crc_size;
      
      CCRC32(crc_type initalValue = CRC32_INIT, 
             bool reverseBitOrder = true, bool finalXor = true);
      crc_type FullCRC(const char *sData, crc_size ulLength);
      void PartialCRC(crc_type *ulInCRC, const char *sData, crc_size ulLength);

   private:
      crc_type mInitialValue;
      bool mReverseBitOrder;
      bool mFinalXor;
      crc_type Reflect(crc_type ulReflect, char cChar);
      crc_type ulTable[256]; // CRC lookup table array.
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
